searchNodes=[{"doc":"Sorting helpers","ref":"EctoJuno.Helpers.SortingHelpers.html","title":"EctoJuno.Helpers.SortingHelpers","type":"module"},{"doc":"Returns atom representation of string from either list of atoms or Ecto.Schema If not found returns nil","ref":"EctoJuno.Helpers.SortingHelpers.html#map_string_field_to_atom/2","title":"EctoJuno.Helpers.SortingHelpers.map_string_field_to_atom/2","type":"function"},{"doc":"Validator module for sorting parameters","ref":"EctoJuno.Helpers.SortingParams.html","title":"EctoJuno.Helpers.SortingParams","type":"module"},{"doc":"Validation function. Relies on Ecto.Changeset . In the end invokes apply_action!/2","ref":"EctoJuno.Helpers.SortingParams.html#changeset!/2","title":"EctoJuno.Helpers.SortingParams.changeset!/2","type":"function"},{"doc":"Module for sorting query","ref":"EctoJuno.Query.Sorting.html","title":"EctoJuno.Query.Sorting","type":"module"},{"doc":"Sorts query ### Parameters query : a query you want to sort schema_or_allowed_fields : either an ecto schema module either a list of which elements are atoms params : a map that can have sort_by , sort_direction keys with string values ### Usage alias EctoJuno.Query.Sorting def sort_users ( sort_by , sort_direction ) do params = %{ &quot;sort_by&quot; =&gt; sort_by , &quot;sort_direction&quot; =&gt; sort_direction } User |&gt; Sorting . sort_query ( User , params ) |&gt; Repo . all ( ) end You can also pass sort_by and sort_direction as atom keys: Sorting . sort_query ( query , User , %{ sort_by : sort_by , sort_direction : sort_direction } ) The default sorting is by inserted_at field with ascending order. For missing sorting parameters the default values will be used. Same applies and for invalid sorting parameters","ref":"EctoJuno.Query.Sorting.html#sort_query/3","title":"EctoJuno.Query.Sorting.sort_query/3","type":"function"},{"doc":"Sorts query by named joint query If query doesn't have provided binding than default sorting will be applied by base query ### Parameters query : a query you want to sort schema_or_allowed_fields : either an ecto schema module either a list of which elements are atoms params : a map that can have sort_by , sort_direction keys with string values binding : joint query name ### Usage alias EctoJuno.Query.Sorting def sort_users_by_posts ( sort_by , sort_direction ) do params = %{ &quot;sort_by&quot; =&gt; sort_by , &quot;sort_direction&quot; =&gt; sort_direction } User |&gt; join ( :left , [ u ] , p in assoc ( u , :posts ) , as : :posts ) |&gt; Sorting . sort_query ( Post , params , :posts ) |&gt; Repo . all ( ) end","ref":"EctoJuno.Query.Sorting.html#sort_query/4","title":"EctoJuno.Query.Sorting.sort_query/4","type":"function"},{"doc":"A simple query sorting library","ref":"readme.html","title":"EctoJuno","type":"extras"},{"doc":"Add :ecto_juno to the list of dependencies in mix.exs def deps do [ { :ecto_juno , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"EctoJuno - Installation","type":"extras"},{"doc":"You can specify default sorting field and mode in your config.exs: config :ecto_juno , sort_by : :id , sort_direction : :desc The default sorting is by inserted_at field with asc mode","ref":"readme.html#configuration","title":"EctoJuno - Configuration","type":"extras"},{"doc":"Lets assume you have Accounts context with User schema and Repo module. To sort users pass your query, schema module and params into EctoJuno.Query.Sorting.sort_query/3 alias EctoJuno.Query.Sorting def list_sorted_users ( params ) do User |&gt; Sorting . sort_query ( User , params ) |&gt; Repo . all ( ) end Where params structure is %{ &quot;sort_by&quot; =&gt; &quot;id&quot; , &quot;sort_direction&quot; =&gt; &quot;desc&quot; } You can also pass sorting parameters keys as atoms: Sorting . sort_query ( query , User , %{ sort_by : &quot;id&quot; , sort_direction : &quot;desc&quot; } ) Moreover, instead of the User schema module, you can pass a list of which elements are atoms: Sorting . sort_query ( query , [ :id , :age , :name , :inserted_at ] , %{ sort_by : &quot;id&quot; , sort_direction : &quot;desc&quot; } ) If you not specify any of sorting parameters, than the default ones will be used: # The default sort_direction will be used Sorting . sort_query ( query , User , %{ sort_by : &quot;id&quot; } ) # The default sort_by will be used Sorting . sort_query ( query , User , %{ sort_direction : &quot;desc&quot; } ) # The default sorting which configurable will be used Sorting . sort_query ( query , User ) If you'll pass invalid sorting parameters, than default sorting ones will be used for your query: Sorting . sort_query ( query , User , %{ sort_by : &quot;invalid_field&quot; , sort_direction : &quot;invalid_mode&quot; } ) by default will sort query by inserted_at field with asc mode","ref":"readme.html#usage","title":"EctoJuno - Usage","type":"extras"},{"doc":"To apply sorting by joint query use EctoJuno.Query.Sorting.sort_query/4 which accepts the same arguments as EctoJuno.Query.Sorting.sort_query/3 except new fourth argument - joint query binding name. Let's assume that you also have a posts table that related to users table as many to one. And posts have title column. Than your sorting function will be something like: alias EctoJuno.Query.Sorting def sort_users_by_posts do params = %{ &quot;sort_by&quot; =&gt; &quot;title&quot; , &quot;sort_direction&quot; =&gt; &quot;desc&quot; } User |&gt; join ( :left , [ u ] , p in assoc ( u , :posts ) , as : :posts ) |&gt; Sorting . sort_query ( Post , params , :posts ) |&gt; Repo . all ( ) end If you provide binding that query doesn't have than sorting by base query in default mode will be applied","ref":"readme.html#sorting-by-joint-query","title":"EctoJuno - Sorting by joint query","type":"extras"},{"doc":"Sorting with modes different from asc and desc is not supported No custom validators for parameters supported If you pass sort_by and sort_direction values not as strings you'll get exception","ref":"readme.html#be-aware-of","title":"EctoJuno - Be aware of","type":"extras"},{"doc":"Clone repo: git clone https://github.com/senconscious/ecto_juno Set DATABASE_URL environment variable before running tests locally Run mix test --cov","ref":"readme.html#testing","title":"EctoJuno - Testing","type":"extras"}]